<div class="container mb-1">
  <div>
    <span class="aligned-with-icon">
      <input
        type="text"
        id="search"
        placeholder="SEARCH"
        (change)="filterTable($event)"
    /></span>

    <mat-icon>search</mat-icon>
  </div>

  <form [formGroup]="searchOptionForm">
    <span>
      <input
        id="id"
        type="radio"
        value="id"
        name="searchOption"
        formControlName="searchOption"
      />
      <label for="id">#ID</label>
    </span>

    &nbsp;

    <span>
      <input
        id="status"
        type="radio"
        value="status"
        name="searchOption"
        formControlName="searchOption"
      />
      <label for="status">Status</label>
    </span>

    &nbsp;

    <span>
      <input
        id="date"
        type="radio"
        value="date"
        name="searchOption"
        formControlName="searchOption"
      />
      <label for="date">Date</label>
    </span>

    &nbsp;

    <span>
      <input
        id="all"
        type="radio"
        value="all"
        name="searchOption"
        formControlName="searchOption"
      />
      <label for="none">All</label>
    </span>
  </form>
</div>

<!-- SUCCESS MESSAGE -->
<app-flash-text
  text="Updated #{{ recentUpdateId }} successfully!"
  [triggerChange]="triggerUpdateMessage"
>
</app-flash-text>

<!-- PAGINATION -->
<div class="container" [ngClass]="'center-pagination'">
  <nav aria-label="Page navigation example">
    <ul class="pagination">
      <!-- PREVIOUS -->
      <li
        class="page-item"
        (click)="decPage()"
        [ngClass]="firstPage ? 'disabled' : ''"
      >
        <a class="page-link">
          <span>&laquo;</span>
        </a>
      </li>

      <!-- PAGE NUMBER -->
      <li class="page-item disabled">
        <a class="page-link" style="color: #0d6efd">{{ pageNumber + 1 }}</a>
      </li>

      <!-- NEXT -->
      <li
        class="page-item"
        [ngClass]="lastPage ? 'disabled' : ''"
        (click)="incPage()"
      >
        <a class="page-link">
          <span>&raquo;</span>
        </a>
      </li>
    </ul>
  </nav>
</div>

<div class="container">
  <div *ngFor="let error of updateShipmentErrors">
    <small class="text-danger">{{ error }}</small>
  </div>
  <!-- TABLE STYLED WITH BOOTSTRAP CLASSES -> 
          scope="col", scope="row" class="table table-bordered table-dark" -->
  <table width="300" class="table table-bordered table-dark">
    <thead>
      <tr>
        <!-- TABLE HEADERS WITH ANIMATED SORTING BUTTONS -->
        <th scope="col">#ID</th>

        <th scope="col">
          <div>Status</div>
          <app-clickable-icon
            (click)="sortByStatusAsc()"
            [icon]="'keyboard_arrow_up'"
          ></app-clickable-icon>
          <app-clickable-icon
            (click)="sortByStatusDesc()"
            [icon]="'keyboard_arrow_down'"
          ></app-clickable-icon>
        </th>

        <th scope="col">
          <div>Issue Date</div>
          <app-clickable-icon
            (click)="sortByDateAsc()"
            [icon]="'keyboard_arrow_up'"
          ></app-clickable-icon>
          <app-clickable-icon
            (click)="sortByDateDesc()"
            [icon]="'keyboard_arrow_down'"
          ></app-clickable-icon>
        </th>

        <th scope="col">
          <div>Colour</div>
          <app-clickable-icon
            (click)="sortByColourAsc()"
            [icon]="'keyboard_arrow_up'"
          ></app-clickable-icon>
          <app-clickable-icon
            (click)="sortByColourDesc()"
            [icon]="'keyboard_arrow_down'"
          ></app-clickable-icon>
        </th>

        <th scope="col">
          <div>Cost NOK</div>
          <app-clickable-icon
            (click)="sortByCostAsc()"
            [icon]="'keyboard_arrow_up'"
          ></app-clickable-icon>
          <app-clickable-icon
            (click)="sortByCostDesc()"
            [icon]="'keyboard_arrow_down'"
          ></app-clickable-icon>
        </th>

        <th scope="col">
          <div>Receiver</div>
          <app-clickable-icon
            (click)="sortByNameAsc()"
            [icon]="'keyboard_arrow_up'"
          ></app-clickable-icon>
          <app-clickable-icon
            (click)="sortByNameDesc()"
            [icon]="'keyboard_arrow_down'"
          ></app-clickable-icon>
        </th>

        <th scope="col">
          <div>Destination</div>
          <app-clickable-icon
            (click)="sortByDestinationAsc()"
            [icon]="'keyboard_arrow_up'"
          ></app-clickable-icon>
          <app-clickable-icon
            (click)="sortByDestinationDesc()"
            [icon]="'keyboard_arrow_down'"
          ></app-clickable-icon>
        </th>

        <th scope="col">
          <div>Weight</div>
          <app-clickable-icon
            (click)="sortByWeightAsc()"
            [icon]="'keyboard_arrow_up'"
          ></app-clickable-icon>
          <app-clickable-icon
            (click)="sortByWeightDesc()"
            [icon]="'keyboard_arrow_down'"
          ></app-clickable-icon>
        </th>
        <!-- Placeholder for edit button column -->
        <th scope="col"></th>
      </tr>
    </thead>
    <tbody>
      <tr [ngClass]="'highlight-on-hover'" *ngFor="let item of tablePageSource">
        <!-- ALWAYS SHOW ID -->
        <td width="20" scope="row">{{ item.id }}</td>

        <!-- TABLE DATA IF NOT EDITING -->
        <!-- STATUS -->
        <td width="100" *ngIf="!item.isEdit" scope="row">{{ item.status }}</td>
        <!-- DATE -->
        <td width="50" *ngIf="!item.isEdit" scope="row">
          {{ item.issue_date }}
        </td>
        <!-- COLOR -->
        <td
          width="60"
          *ngIf="!item.isEdit"
          scope="row"
          [style.background]="item.box_colour"
        ></td>
        <!-- COST -->
        <td width="60" *ngIf="!item.isEdit" scope="row">
          {{ item.cost }}
        </td>
        <!-- RECEIVER -->
        <td width="80" *ngIf="!item.isEdit" scope="row">
          {{ item.receiver_name }}
        </td>
        <!-- DESTINATION -->
        <td width="70" *ngIf="!item.isEdit" scope="row">
          {{ getCountryName(item.destination_id) }}
        </td>
        <!-- WEIGHT -->
        <td width="50" *ngIf="!item.isEdit" scope="row">
          {{ item.weight }}
        </td>
        <!-- EDIT BUTTON -->
        <td width="50" *ngIf="!item.isEdit" scope="row">
          <app-clickable-icon
            (click)="item.isEdit = !item.isEdit"
            [icon]="'edit'"
          ></app-clickable-icon>
          <!-- <mat-icon (click)="item.isEdit = !item.isEdit">edit</mat-icon> -->
        </td>

        <!-- TABLE DATA BECOMES FORM, IF EDITING -->
        <!-- STATUS -->
        <td *ngIf="item.isEdit" scope="row">
          <select [(ngModel)]="item.status" class="form-select form-select-sm">
            <option [defaultSelected]>{{ item.status }}</option>
            <option *ngIf="item.status != 'CREATED'" value="CREATED">
              CREATED
            </option>
            <option *ngIf="item.status != 'RECEIVED'" value="RECEIVED">
              RECEIVED
            </option>
            <option *ngIf="item.status != 'INTRANSIT'" value="INTRANSIT">
              INTRANSIT
            </option>
            <option *ngIf="item.status != 'COMPLETED'" value="COMPLETED">
              COMPLETED
            </option>
          </select>
        </td>
        <!-- DATE -->
        <td *ngIf="item.isEdit" scope="row">
          <input [(ngModel)]="item.issue_date" type="date" />
        </td>
        <!-- COLOR -->
        <td
          *ngIf="item.isEdit"
          scope="row"
          [style.background]="item.box_colour"
        >
          <input [(ngModel)]="item.box_colour" type="text" />
        </td>
        <!-- COST -->
        <td *ngIf="item.isEdit" scope="row">
          <input [(ngModel)]="item.cost" type="text" />
        </td>
        <!-- RECEIVER -->
        <td *ngIf="item.isEdit" scope="row">
          <input [(ngModel)]="item.receiver_name" type="text" />
        </td>
        <!-- DESTINATION -->
        <td *ngIf="item.isEdit" scope="row">
          <select
            [(ngModel)]="item.destination_id"
            class="form-select form-select-sm"
            size="3"
          >
            <option *ngFor="let item of countryList" [ngValue]="item.id">
              {{ item.country_name }}
            </option>
          </select>
        </td>
        <!-- WEIGHT -->
        <td *ngIf="item.isEdit" scope="row">
          <select [(ngModel)]="item.weight" class="form-select form-select-sm">
            <option value="1">basic - 1kg</option>
            <option value="2">humble - 2kg</option>
            <option value="5">deluxe - 5kg</option>
            <option value="8">premium - 8kg</option>
          </select>
        </td>

        <!-- BUTTONS -->
        <td *ngIf="item.isEdit" scope="row">
          <!-- UPLOAD BUTTON -->
          <app-clickable-icon
            (click)="updateShipment(item)"
            [icon]="'cloud_upload'"
          ></app-clickable-icon>
          <!-- <mat-icon (click)="updateShipment(item)">cloud_upload</mat-icon> -->
          <!-- CANCEL BUTTON -->
          <app-clickable-icon
            (click)="cancelUpdate(item)"
            [icon]="'cancel'"
          ></app-clickable-icon>
          <!-- <mat-icon (click)="cancelUpdate(item)">cancel</mat-icon> -->
        </td>
      </tr>
    </tbody>
  </table>

  <p *ngIf="hasSearched && dataSource.length == 0" class="text-danger">
    No results found.
  </p>
</div>
